# -*- rpm-spec -*-

%define real_name               python
%define numver                  21

Name: %real_name%numver
Version: 2.1.3
Release: alt5.1

%define dirver			2.1
%define namever			%real_name%dirver
%define __python_version	%version
%define __python		%_builddir/Python-%version/%real_name

Summary: An interpreted, interactive object-oriented programming language
License: PSF
Group: Development/Python
Url: http://www.python.org/
Packager: Python Development Team <python@packages.altlinux.org>

Source: Python-%version.tar.bz2

Patch1: Python-2.1-build.patch
Patch2: Python-2.1.1-db.patch
Patch3: Python-2.1.1-alt-compileall.patch
Patch4: Python-2.1.1-cgi.patch
Patch5: Python-2.1.3-buildreq.patch
Patch6: Python-2.1.3-alt-tinfo.patch
Patch7: Python-2.1-setup.patch
Patch8: Python-2.1-execvpe.patch

Provides: %real_name = %dirver
Provides: %_bindir/%real_name
Obsoletes: %real_name

PreReq: alternatives >= 0.0.6

BuildPreReq: rpm >= 4.0.3-alt3, autoconf = 2.13, tcl-devel >= 8.4.0-alt1, tk-devel >= 8.4.0-alt1

# Automatically added by buildreq on Thu Mar 13 2003
BuildRequires: XFree86-devel gcc-c++ libalternatives-devel libdb2-devel libexpat-devel libgdbm-devel libgmp-devel libncurses-devel libreadline-devel libssl-devel libstdc++-devel libtcl libtinfo-devel libtk python tcl-devel tk-devel zlib-devel

%description
Python is an interpreted, interactive, object-oriented programming
language often compared to Tcl, Perl, Scheme or Java. Python includes
modules, classes, exceptions, very high level dynamic data types and
dynamic typing. Python supports interfaces to many system calls and
libraries, as well as to various windowing systems (X11, Motif, Tk,
Mac and MFC).

Programmers can write new built-in modules for Python in C or C++.
Python can be used as an extension language for applications that
need a programmable interface. This package contains most of the
standard Python modules, as well as modules for interfacing to the
Tix widget set for Tk and RPM.

Note that documentation for Python is provided in the python-docs
package.

%package devel
Summary: The libraries and header files needed for Python development
Group: Development/Python
Requires: %name = %version-%release
Provides: %real_name-devel = %dirver
Obsoletes: %real_name-devel

%description devel
The Python programming language's interpreter can be extended with
dynamically loaded extensions and can be embedded in other programs.
This package contains the header files and libraries needed to do
these types of tasks.

Install this package if you want to develop Python extensions.  The
%name package will also need to be installed.  You'll probably also
want to install the python-docs package, which contains Python
documentation.

%package -n tkinter%numver
Summary: A graphical user interface for the Python scripting language
Group: Development/Python
Requires: %name = %version-%release tk >= 8.4.0-alt1
PreReq: alternatives >= 0.0.6
Provides: tkinter = %dirver
Obsoletes: tkinter

%description -n tkinter%numver
The Tkinter (Tk interface) program is an graphical user interface for
the Python scripting language.

You should install this package if you'd like to use a graphical
user interface for Python programming.

%prep
%setup -q -n Python-%version
%patch1 -p0
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p0

find -type f \( -name \*~ -o -name \*.orig \) -print0 |
	xargs -r0 rm -f

%build
autoconf_2.13

echo ': ${LDSHARED='gcc -shared'}' > config.cache
echo ': ${LINKFORSHARED='-rdynamic'}' >> config.cache
echo ': ${CFLAGSFORSHARED='-fPIC'}' >> config.cache

export OPT="$RPM_OPT_FLAGS -D_GNU_SOURCE"
export MACHDEP=%_target_os-%_target_cpu
%configure --with-threads --with-cycle-gc --with-libdb
Tools/scripts/pathfix.py -i "/usr/bin/python" .
%make_build

#make test

%install
mkdir -p $RPM_BUILD_ROOT%_mandir

#  set the install path
echo '[install_scripts]' >setup.cfg
echo 'install_dir='"$RPM_BUILD_ROOT/usr/bin" >>setup.cfg

%makeinstall MANDIR=$RPM_BUILD_ROOT%_mandir

# Relocate pydoc.
mv $RPM_BUILD_ROOT%_bindir/pydoc $RPM_BUILD_ROOT%_bindir/pydoc%dirver

# idle
mkdir -p $RPM_BUILD_ROOT%_libdir/%namever/site-packages
cat << EOF > $RPM_BUILD_ROOT%_bindir/idle%dirver
#!/bin/sh
exec %_libdir/%namever/site-packages/idle/idle.py
EOF
cp -r Tools/idle $RPM_BUILD_ROOT%_libdir/%namever/site-packages/

# modulator
cat << EOF > $RPM_BUILD_ROOT%_bindir/modulator%dirver
#!/bin/sh
exec %_libdir/%namever/site-packages/modulator/modulator.py
EOF
cp -r Tools/modulator $RPM_BUILD_ROOT%_libdir/%namever/site-packages/

# pynche
cat << EOF > $RPM_BUILD_ROOT%_bindir/pynche%dirver
#!/bin/sh
exec %_libdir/%namever/site-packages/pynche/pynche
EOF
rm -f Tools/pynche/*.pyw
cp -r Tools/pynche $RPM_BUILD_ROOT%_libdir/%namever/site-packages/

chmod 755 $RPM_BUILD_ROOT%_bindir/{idle,modulator,pynche}%dirver

ln -f Tools/modulator/README Tools/modulator/README.modulator
ln -f Tools/pynche/README Tools/pynche/README.pynche

rm -f modules-list.full
for n in $RPM_BUILD_ROOT/usr/lib/%namever/*; do
  [ -d $n ] || echo $n
done >> modules-list.full

for mod in $RPM_BUILD_ROOT/usr/lib/%namever/lib-dynload/* ; do
  [ `basename $mod` = _tkinter.so ] || echo $mod
done >> modules-list.full
sed -e "s|$RPM_BUILD_ROOT||g" < modules-list.full > modules-list

# menu support
install -d $RPM_BUILD_ROOT%_menudir
cat > $RPM_BUILD_ROOT%_menudir/tkinter-%version << EOF
?package(tkinter%numver): needs="gnome" section="Applications/Development/Development environments" title="IDLE" \
longtitle="IDE for Python %version" command="NO_XALF %_bindir/idle%dirver" icon="development_section.xpm"
?package(tkinter%numver): needs=x11 section="Applications/Development/Development environments" title="IDLE" \
longtitle="IDE for Python %version" command="%_bindir/idle%dirver" icon="development_section.xpm"
EOF

#alternatives support
install -d $RPM_BUILD_ROOT%_altdir
#main package
cat >$RPM_BUILD_ROOT%_altdir/%namever << EOF
<group name="candidate">
    <option name="link">%_bindir/%real_name</option>
    <option name="real">%_bindir/%namever</option>
    <option name="weight" type="number">%numver</option>
    <group name="slave">
        <option name="link">%_bindir/pydoc</option>
        <option name="real">%_bindir/pydoc%dirver</option>
    </group>
</group>
EOF
#tkinter package
>$RPM_BUILD_ROOT%_altdir/tkinter%numver
for n in idle modulator pynche
do
cat >>$RPM_BUILD_ROOT%_altdir/tkinter%numver<<EOF
<group name="candidate">
    <option name="link">%_bindir/$n</option>
    <option name="real">%_bindir/${n}%dirver</option>
    <option name="weight" type="number">%numver</option>
</group>
EOF
done

chmod -x $RPM_BUILD_ROOT/usr/lib/%namever/test/*.py*

find $RPM_BUILD_ROOT -type f -print0 |
    xargs -r0 fgrep -l $RPM_BUILD_ROOT |
	xargs -r perl -pi -e "s|$RPM_BUILD_ROOT||g"

mkdir -p $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d
echo %real_name >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%real_name%numver
echo %real_name-devel >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/%real_name%numver-devel
echo tkinter >$RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/tkinter%numver
chmod 644 $RPM_BUILD_ROOT%_sysconfdir/buildreqs/packages/substitute.d/*

%post
%register_alternatives %namever -- python pydoc

%triggerpostun -- %real_name
%register_alternatives %namever -- python pydoc

%preun
%unregister_alternatives %namever

%post -n tkinter%numver
%register_alternatives tkinter%numver -- idle modulator pynche
%update_menus

%triggerpostun -- tkinter
%register_alternatives tkinter%numver -- idle modulator pynche

%preun -n tkinter%numver
%unregister_alternatives tkinter%numver

%postun -n tkinter%numver
%clean_menus

%files -f modules-list
%config %_sysconfdir/buildreqs/packages/substitute.d/%real_name%numver
%_altdir/%namever
%_bindir/%namever
%_bindir/pydoc%dirver
%dir %_libdir/%namever
%dir %_libdir/%namever/lib-dynload
%dir %_libdir/%namever/site-packages
%_libdir/%namever/curses
%_libdir/%namever/distutils
%_libdir/%namever/encodings
%_libdir/%namever/lib-old
%_libdir/%namever/plat-linux-*
%_libdir/%namever/xml
#%_libdir/%namever/*.py*
%_mandir/man?/*
%doc LICENSE Lib/*.doc
%doc Misc/{HISTORY,HYPE,NEWS,cheatsheet,BLURB*}

%files devel
%config %_sysconfdir/buildreqs/packages/substitute.d/%real_name%numver-devel
%_includedir/%namever
%_libdir/%namever/config
%_libdir/%namever/test

%files -n tkinter%numver
%config %_sysconfdir/buildreqs/packages/substitute.d/tkinter%numver
%_altdir/tkinter%numver
%_libdir/%namever/lib-tk
%_libdir/%namever/lib-dynload/_tkinter.so
%_libdir/%namever/site-packages/*
%_menudir/tkinter-%version
%_bindir/idle%dirver
%_bindir/modulator%dirver
%_bindir/pynche%dirver

%changelog
* Wed Apr 09 2003 Stanislav Ievlev <inger@altlinux.ru> 2.1.3-alt5.1
- new alternatives config format

* Fri Mar 14 2003 Stanislav Ievlev <inger@altlinux.ru> 2.1.3-alt5
- PreReq fixes

* Thu Mar 13 2003 Stanislav Ievlev <inger@altlinux.ru> 2.1.3-alt4
- move to new alternatives scheme

* Mon Dec 09 2002 Dmitry V. Levin <ldv@altlinux.org> 2.1.3-alt3
- Fixed execvp issue.
- Built with libgdbm.so.3.
- Patched to link with libtinfo.

* Thu Sep 26 2002 Sergey Bolshakov <s.bolshakov@belcaf.com> 2.1.3-alt2
- rebuilt with tcl 8.4

* Thu Apr 25 2002 Stanislav Ievlev <inger@altlinux.ru> 2.1.3-alt1
- 2.1.3
- fixed buildreq

* Thu Mar 07 2002 Stanislav Ievlev <inger@altlinux.ru> 2.1.1-alt6
- fixed alternatives

* Wed Jan 30 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.1.1-alt5
- Added buildreq substitution rules.

* Tue Jan 29 2002 Dmitry V. Levin <ldv@alt-linux.org> 2.1.1-alt4
- Renamed to python21.
- Fixed compileall module (#0000072).
- Dropped emacs bindings (moved to python22).

* Tue Sep 04 2001 Mikhail Zabaluev <mhz@altlinux.ru> 2.1.1-alt3
- Segregated python-docs into a separate package

* Mon Aug 06 2001 Stanislav Ievlev <inger@altlinux.ru> 2.1.1-alt2
- Added emacs to buildreqs

* Wed Aug 01 2001 Stanislav Ievlev <inger@altlinux.ru> 2.1.1-alt1
- 2.1.1
- Light spec cleanup.

* Wed Jun 26 2001 AEN <aen@logic.ru> 2.1-alt1
- new version

* Tue Jan 30 2001 Dmitry V. Levin <ldv@fandra.org> 2.0-ipl5mdk
- Explicit set strip methods.
- Added few patches from
  http://www.python.org/cgi-bin/moinmoin/{Critical,Misc}Patches/

* Mon Jan 15 2001 Dmitry V. Levin <ldv@fandra.org> 2.0-ipl4mdk
- Fix build with new expat-devel.

* Sat Dec 09 2000 Dmitry V. Levin <ldv@fandra.org> 2.0-ipl3mdk
- Specfile cleanup.
- Enabled bsddbmodule.
- Added %_libdir/%namever/xml.
- Recompiled modules with the correct directory paths.
- Automatically added BuildRequires.

* Wed Nov 29 2000 AEN <aen@logic.ru> 2.0-ipl2mdk
- build for RE
- corrected BuildReq

* Fri Nov 17 2000 Frederic Lepied <flepied@mandrakesoft.com> 2.0-1mdk
- 2.0 (95 tests OK. 12 tests skipped: test_al test_cd test_cl test_dl test_gl test_imgfile test_largefile
test_linuxaudiodev test_nis test_sunaudiodev test_winreg test_winsound)
- added emacs mode
- html doc.

* Wed Sep 27 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-12mdk
- removed dependency on tkinter for python to avoid loop.

* Mon Sep 11 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-11mdk
- fixed some hardcoded paths (Geoffrey Lee).
- removed menu entry for interpreter.

* Thu Aug 10 2000 Guillaume Cottenceau <gc@mandrakesoft.com> 1.5.2-10mdk
- fixed typo %updates_menus -> %update_menus

* Mon Aug 07 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-9mdk
- automatically added BuildRequires

* Thu Aug  3 2000 Chmouel Boudjnah <chmouel@mandrakesoft.com> 1.5.2-8mdk
- Merge rh patch.
- Macros.
- compile with new tcl.

* Tue May  9 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-7mdk
- added locale module.

* Thu Mar 30 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-6mdk
- menu

* Tue Mar  7 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-5mdk
- idle 0.5.
- compiled with optimization.

* Fri Jan 14 2000 Frederic Lepied <flepied@mandrakesoft.com> 1.5.2-4mdk

- added a BuildRequires.

* Sat Dec 4 1999 Florent Villard <warly@mandrakesoft.com>
- add idle, pynche and modulator in the package

* Tue Oct 19 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Merge with redhat changes.
- added modulator, and pynche to the python-tools package(r)
- using a files list in the %files section for python-tools(r)
- added conflicts/requires between subpackages so that you cannot
  have an older tkinter installed with a new python.(r)
- added more tools(r)
- rebuild to fix broken tkinter.(r)
- fixed bogus /usr/local/bin/python requirements.(r)
- added patch to import global symbols until we get libtool patched(r)

* Fri Aug 20 1999 Pablo Saratxaga <pablo@mandrakesoft.com>
- updated to 1.5.2
- updated patches
- use macro %%_arch instead of %%_target_cpu for file paths

* Tue Apr 13 1999 Chmouel Boudjnah <chmouel@mandrakesoft.com>
- Remove the dbm support (doen't work with GLBC2.1)

* Sat Apr 10 1999 Bernhard Rosenkraenzer <bero@linux-mandrake.com>
- Mandrake adaptions
- add de locale
- fix handling of RPM_OPT_FLAGS

* Thu Feb 11 1999 Michael Johnson <johnsonm@redhat.com>
- added mpzmodule at user request (uses gmp)
- added bsddbmodule at user request (uses db 1.85 interface)

* Mon Feb 08 1999 Michael Johnson <johnsonm@redhat.com>
- add --with-threads at user request
- clean up spec file

* Fri Jan 08 1999 Michael K. Johnson <johnsonm@redhat.com>
- New libc changes ndbm.h to db1/ndbm.h and -ldb to -ldb1

* Thu Sep  3 1998 Jeff Johnson <jbj@redhat.com>
- recompile for RH 5.2.

* Wed May 06 1998 Cristian Gafton <gafton@redhat.com>
- python-docs used to require /usr/bin/sed. Changed to /bin/sed instead

* Wed Apr 29 1998 Cristian Gafton <gafton@redhat.com>
- fixed the spec file for version 1.5.1
- buildroot (!)

* Mon Apr 20 1998 Michael K. Johnson <johnsonm@redhat.com>
- updated to python 1.5.1
- created our own Python-Doc tar file from 1.5 to substitute for the
  not-yet-released Doc package.
- build _tkinter properly
- use readline again
- build crypt module again
- install rand replacement module
- added a few modules

* Thu Apr 09 1998 Erik Troan <ewt@redhat.com>
- updated to python 1.5
- made /usr/lib/python1.5 file list automatically generated

* Tue Nov 04 1997 Michael K. Johnson <johnsonm@redhat.com>
- Fixed dependencies for python and tkinter

* Mon Nov 03 1997 Michael K. Johnson <johnsonm@redhat.com>
- pulled out tk-related stuff into tkinter package

* Fri Oct 10 1997 Erik Troan <ewt@redhat.com>
- bunches of scripts used /usr/local/bin/python instead of /usr/bin/python

* Tue Sep 30 1997 Erik Troan <ewt@redhat.com>
- updated for tcl/tk 8.0

* Thu Jul 10 1997 Erik Troan <ewt@redhat.com>
- built against glibc
